/*
 * Copyright 2012 Project UNKONW.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND,
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package jp.techie.plain.framework.action;

import static org.junit.Assert.assertEquals;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.io.UnsupportedEncodingException;
import java.security.Principal;
import java.util.Collection;
import java.util.Enumeration;
import java.util.Locale;
import java.util.Map;

import javax.servlet.AsyncContext;
import javax.servlet.DispatcherType;
import javax.servlet.RequestDispatcher;
import javax.servlet.ServletContext;
import javax.servlet.ServletException;
import javax.servlet.ServletInputStream;
import javax.servlet.ServletOutputStream;
import javax.servlet.ServletRequest;
import javax.servlet.ServletResponse;
import javax.servlet.http.Cookie;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import javax.servlet.http.Part;

import jp.techie.plain.framework.util.TemplateUtil;

import org.junit.Test;

/**
 * OutputHtmlRestActionImplTest
 * 
 * @author bose999
 *
 */
public class OutputHtmlRestActionImplTest {

    private static String TEST_DATA = "testData";

    /**
     * getHtml()テスト
     * TemplateUtil が返す文字列が同じになることをテストする
     */
    @Test
    public void testGetHtml() {
        OutputHtmlRestActionImpl outputHtmlRestActionImpl = new OutputHtmlRestActionImpl();
        HttpServletRequestMock request = new HttpServletRequestMock();
        HttpServletResponseMock response = new HttpServletResponseMock();
        outputHtmlRestActionImpl.templateUtil = new TemplateUtilMock();
        String result = outputHtmlRestActionImpl.getHtml(request, response, "");
        assertEquals(result, TEST_DATA);
    }

    /**
     * TemplateUtilMock
     * 
     * @author bose999
     *
     */
    private class TemplateUtilMock extends TemplateUtil {
        public TemplateUtilMock() {
        }

        public String buildHtml(HttpServletRequest request, String templateName) {
            return TEST_DATA;
        }
    }

    /**
     * HttpServletRequestMock
     * 
     * @author bose999
     *
     */
    private static class HttpServletRequestMock implements HttpServletRequest {

        @Override
        public AsyncContext getAsyncContext() {
            return null;
        }

        @Override
        public Object getAttribute(String arg0) {
            return null;
        }

        @Override
        public Enumeration<String> getAttributeNames() {
            return null;
        }

        @Override
        public String getCharacterEncoding() {
            return null;
        }

        @Override
        public int getContentLength() {
            return 0;
        }

        @Override
        public String getContentType() {
            return null;
        }

        @Override
        public DispatcherType getDispatcherType() {
            return null;
        }

        @Override
        public ServletInputStream getInputStream() throws IOException {
            return null;
        }

        @Override
        public String getLocalAddr() {
            return null;
        }

        @Override
        public String getLocalName() {
            return null;
        }

        @Override
        public int getLocalPort() {
            return 0;
        }

        @Override
        public Locale getLocale() {
            return null;
        }

        @Override
        public Enumeration<Locale> getLocales() {
            return null;
        }

        @Override
        public String getParameter(String arg0) {
            return null;
        }

        @Override
        public Map<String, String[]> getParameterMap() {
            return null;
        }

        @Override
        public Enumeration<String> getParameterNames() {
            return null;
        }

        @Override
        public String[] getParameterValues(String arg0) {
            return null;
        }

        @Override
        public String getProtocol() {
            return null;
        }

        @Override
        public BufferedReader getReader() throws IOException {
            return null;
        }

        @Override
        public String getRealPath(String arg0) {
            return null;
        }

        @Override
        public String getRemoteAddr() {
            return null;
        }

        @Override
        public String getRemoteHost() {
            return null;
        }

        @Override
        public int getRemotePort() {
            return 0;
        }

        @Override
        public RequestDispatcher getRequestDispatcher(String arg0) {
            return null;
        }

        @Override
        public String getScheme() {
            return null;
        }

        @Override
        public String getServerName() {
            return null;
        }

        @Override
        public int getServerPort() {
            return 0;
        }

        @Override
        public ServletContext getServletContext() {
            return null;
        }

        @Override
        public boolean isAsyncStarted() {
            return false;
        }

        @Override
        public boolean isAsyncSupported() {
            return false;
        }

        @Override
        public boolean isSecure() {
            return false;
        }

        @Override
        public void removeAttribute(String arg0) {
        }

        @Override
        public void setAttribute(String arg0, Object arg1) {
        }

        @Override
        public void setCharacterEncoding(String arg0) throws UnsupportedEncodingException {
        }

        @Override
        public AsyncContext startAsync() throws IllegalStateException {
            return null;
        }

        @Override
        public AsyncContext startAsync(ServletRequest arg0, ServletResponse arg1) throws IllegalStateException {
            return null;
        }

        @Override
        public boolean authenticate(HttpServletResponse arg0) throws IOException, ServletException {
            return false;
        }

        @Override
        public String getAuthType() {
            return null;
        }

        @Override
        public String getContextPath() {
            return null;
        }

        @Override
        public Cookie[] getCookies() {
            return null;
        }

        @Override
        public long getDateHeader(String arg0) {
            return 0;
        }

        @Override
        public String getHeader(String arg0) {
            return null;
        }

        @Override
        public Enumeration<String> getHeaderNames() {
            return null;
        }

        @Override
        public Enumeration<String> getHeaders(String arg0) {
            return null;
        }

        @Override
        public int getIntHeader(String arg0) {
            return 0;
        }

        @Override
        public String getMethod() {
            return null;
        }

        @Override
        public Part getPart(String arg0) throws IOException, ServletException {
            return null;
        }

        @Override
        public Collection<Part> getParts() throws IOException, ServletException {
            return null;
        }

        @Override
        public String getPathInfo() {
            return null;
        }

        @Override
        public String getPathTranslated() {
            return null;
        }

        @Override
        public String getQueryString() {
            return null;
        }

        @Override
        public String getRemoteUser() {
            return null;
        }

        @Override
        public String getRequestURI() {
            return null;
        }

        @Override
        public StringBuffer getRequestURL() {
            return null;
        }

        @Override
        public String getRequestedSessionId() {
            return null;
        }

        @Override
        public String getServletPath() {
            return null;
        }

        @Override
        public HttpSession getSession() {
            return null;
        }

        @Override
        public HttpSession getSession(boolean arg0) {
            return null;
        }

        @Override
        public Principal getUserPrincipal() {
            return null;
        }

        @Override
        public boolean isRequestedSessionIdFromCookie() {
            return false;
        }

        @Override
        public boolean isRequestedSessionIdFromURL() {
            return false;
        }

        @Override
        public boolean isRequestedSessionIdFromUrl() {
            return false;
        }

        @Override
        public boolean isRequestedSessionIdValid() {
            return false;
        }

        @Override
        public boolean isUserInRole(String arg0) {
            return false;
        }

        @Override
        public void login(String arg0, String arg1) throws ServletException {
        }

        @Override
        public void logout() throws ServletException {
        }
    }

    /**
     * HttpServletResponseMock
     * 
     * @author bose999
     *
     */
    private static class HttpServletResponseMock implements HttpServletResponse {

        @Override
        public void flushBuffer() throws IOException {
        }

        @Override
        public int getBufferSize() {
            return 0;
        }

        @Override
        public String getCharacterEncoding() {
            return null;
        }

        @Override
        public String getContentType() {
            return null;
        }

        @Override
        public Locale getLocale() {
            return null;
        }

        @Override
        public ServletOutputStream getOutputStream() throws IOException {
            return null;
        }

        @Override
        public PrintWriter getWriter() throws IOException {
            return null;
        }

        @Override
        public boolean isCommitted() {
            return false;
        }

        @Override
        public void reset() {
        }

        @Override
        public void resetBuffer() {
        }

        @Override
        public void setBufferSize(int arg0) {
        }

        @Override
        public void setCharacterEncoding(String arg0) {
        }

        @Override
        public void setContentLength(int arg0) {
        }

        @Override
        public void setContentType(String arg0) {
        }

        @Override
        public void setLocale(Locale arg0) {
        }

        @Override
        public void addCookie(Cookie arg0) {
        }

        @Override
        public void addDateHeader(String arg0, long arg1) {
        }

        @Override
        public void addHeader(String arg0, String arg1) {
        }

        @Override
        public void addIntHeader(String arg0, int arg1) {
        }

        @Override
        public boolean containsHeader(String arg0) {
            return false;
        }

        @Override
        public String encodeRedirectURL(String arg0) {
            return null;
        }

        @Override
        public String encodeRedirectUrl(String arg0) {
            return null;
        }

        @Override
        public String encodeURL(String arg0) {
            return null;
        }

        @Override
        public String encodeUrl(String arg0) {
            return null;
        }

        @Override
        public String getHeader(String arg0) {
            return null;
        }

        @Override
        public Collection<String> getHeaderNames() {
            return null;
        }

        @Override
        public Collection<String> getHeaders(String arg0) {
            return null;
        }

        @Override
        public int getStatus() {
            return 0;
        }

        @Override
        public void sendError(int arg0) throws IOException {
        }

        @Override
        public void sendError(int arg0, String arg1) throws IOException {
        }

        @Override
        public void sendRedirect(String arg0) throws IOException {
        }

        @Override
        public void setDateHeader(String arg0, long arg1) {
        }

        @Override
        public void setHeader(String arg0, String arg1) {
        }

        @Override
        public void setIntHeader(String arg0, int arg1) {
        }

        @Override
        public void setStatus(int arg0) {
        }

        @Override
        public void setStatus(int arg0, String arg1) {
        }
    }
}
